package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: TransactionType
// UnionValue: BlockValidatorAnchor

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("BlockValidatorAnchor")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class BlockValidatorAnchor implements TransactionBody {
	public final TransactionType type = TransactionType.BLOCK_VALIDATOR_ANCHOR;
	private Url source;
	private long majorBlockIndex;
	private long minorBlockIndex;
	private long rootChainIndex;
	private byte[] rootChainAnchor;
	private byte[] stateTreeAnchor;
	private java.math.BigInteger acmeBurnt;

    //
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public BlockValidatorAnchor source(final Url value) {
	    setSource(value);
	    return this;
	}
	public BlockValidatorAnchor source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public long getMajorBlockIndex() {
	    return majorBlockIndex;
	}
	public void setMajorBlockIndex(final long value) {
	    this.majorBlockIndex = value;
	}

	public BlockValidatorAnchor majorBlockIndex(final long value) {
	    setMajorBlockIndex(value);
	    return this;
	}
	public long getMinorBlockIndex() {
	    return minorBlockIndex;
	}
	public void setMinorBlockIndex(final long value) {
	    this.minorBlockIndex = value;
	}

	public BlockValidatorAnchor minorBlockIndex(final long value) {
	    setMinorBlockIndex(value);
	    return this;
	}
	public long getRootChainIndex() {
	    return rootChainIndex;
	}
	public void setRootChainIndex(final long value) {
	    this.rootChainIndex = value;
	}

	public BlockValidatorAnchor rootChainIndex(final long value) {
	    setRootChainIndex(value);
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getRootChainAnchor() {
	    return rootChainAnchor;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setRootChainAnchor(final byte[] value) {
	    this.rootChainAnchor = value;
	}

	public BlockValidatorAnchor rootChainAnchor(final byte[] value) {
	    setRootChainAnchor(value);
	    return this;
	}
	public BlockValidatorAnchor rootChainAnchor(final String value) {
		try {
			setRootChainAnchor(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getStateTreeAnchor() {
	    return stateTreeAnchor;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setStateTreeAnchor(final byte[] value) {
	    this.stateTreeAnchor = value;
	}

	public BlockValidatorAnchor stateTreeAnchor(final byte[] value) {
	    setStateTreeAnchor(value);
	    return this;
	}
	public BlockValidatorAnchor stateTreeAnchor(final String value) {
		try {
			setStateTreeAnchor(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getAcmeBurnt() {
	    return acmeBurnt;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setAcmeBurnt(final java.math.BigInteger value) {
	    this.acmeBurnt = value;
	}

	public BlockValidatorAnchor acmeBurnt(final java.math.BigInteger value) {
	    setAcmeBurnt(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.source == null)) {
            marshaller.writeUrl(2, this.source);
        }
        if (!(this.majorBlockIndex == 0)) {
            marshaller.writeUint(3, this.majorBlockIndex);
        }
        if (!(this.minorBlockIndex == 0)) {
            marshaller.writeUint(4, this.minorBlockIndex);
        }
        if (!(this.rootChainIndex == 0)) {
            marshaller.writeUint(5, this.rootChainIndex);
        }
        if (!(this.rootChainAnchor == null || this.rootChainAnchor.length == 0)) {
            marshaller.writeHash(6, this.rootChainAnchor);
        }
        if (!(this.stateTreeAnchor == null || this.stateTreeAnchor.length == 0)) {
            marshaller.writeHash(7, this.stateTreeAnchor);
        }
        if (!((this.acmeBurnt).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(8, this.acmeBurnt);
        }
        return marshaller.array();
    }
}
